var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
  var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
  if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
  else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { h } from '@stencil/core';
import { MapToComponentField, VegaSlimmer } from 'vega-slimmer/core';
import { DomNodeSubjectObserverFactory } from '../../../../helpers/change-manager/subject/dom-node-subject/dom-node-subject-observer-factory';
import { VegaClick } from '../../../../helpers/event-manager/event-id/vega-event-id';
import { VegaInternalIconManager } from '../../../../helpers/icon/internal-icon-manager';
import eye from '../../../../global/icons/eye';
import eyeSlash from '../../../../global/icons/eye-slash';
export class VegaInputPasswordEyeRenderer extends VegaSlimmer {
  render() {
    const iconKey = this.isPasswordDisplay ? 'eye' : 'eye-slash';
    return (h("vega-button-circle", { icon: VegaInternalIconManager.getIconKey(iconKey), variant: "icon-only", size: "small", class: "password-eye-button", ref: (ref) => {
        this.addEyeIconObserver(ref);
      } }));
  }
  addEyeIconObserver(eyeIconRef) {
    DomNodeSubjectObserverFactory.addUniqueObserverToNode(eyeIconRef, VegaClick, () => {
      this.isPasswordDisplay = !this.isPasswordDisplay;
    });
  }
}
(() => {
  VegaInternalIconManager.register({
    'eye': eye,
    'eye-slash': eyeSlash,
  });
})();
__decorate([
  MapToComponentField()
], VegaInputPasswordEyeRenderer.prototype, "host", void 0);
__decorate([
  MapToComponentField({ writable: true })
], VegaInputPasswordEyeRenderer.prototype, "isPasswordDisplay", void 0);
__decorate([
  MapToComponentField()
], VegaInputPasswordEyeRenderer.prototype, "type", void 0);
